# OrdersWindow Struct Reference

Order window code for all vehicles. More...

Inheritance diagram for OrdersWindow:

## Data Structures
struct | KeyToEvent
## Public Member Functions
| OrdersWindow (const WindowDesc *desc, const Vehicle *v)
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | OnInvalidateData (int data)
| Some data on this window has become invalid.
void | UpdateButtonState ()
virtual void | OnPaint ()
| The window must be repainted.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
virtual void | SetStringParameters (int widget) const
| Initialize string parameters for a widget.
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
virtual void | OnQueryTextFinished (char *str)
| The query window opened from this window has closed.
virtual void | OnDropdownSelect (int widget, int index)
| A dropdown option associated to this window has been selected.
virtual void | OnDragDrop (Point pt, int widget)
| A dragged 'object' has been released.
virtual EventState | OnKeyPress (uint16 key, uint16 keycode)
| A key has been pressed.
virtual void | OnPlaceObject (Point pt, TileIndex tile)
| The user clicked some place on the map when a tile highlight mode has been set.
virtual void | OnPlaceObjectAbort ()
| The user cancelled a tile highlight mode that has been set.
virtual void | OnMouseLoop ()
| Called for every mouse loop run, which is at least once per (game) tick.
virtual void | OnResize ()
| Called after the window got resized.
virtual void | OnTimeout ()
| Called when this window's timeout has been reached.
## Private Types
enum | OrderPlaceObjectState { OPOS_GOTO, OPOS_CONDITIONAL }
| Under what reason are we using the PlaceObject functionality?
enum | DisplayPane { DP_LEFT_NONSTOP = 0, DP_LEFT_CONDVAR = 1, DP_MIDDLE_LOAD = 0, DP_MIDDLE_REFIT = 1, DP_MIDDLE_COMPARE = 2, DP_RIGHT_UNLOAD = 0, DP_RIGHT_SERVICE = 1, DP_RIGHT_CONDVAL = 2, DP_ROW_LOAD = 0, DP_ROW_DEPOT = 1, DP_ROW_CONDITIONAL = 2 }
| Displayed planes of the NWID_SELECTION widgets. More...
typedef void(OrdersWindow::* | Handler )(int)
## Private Member Functions
int | OrderGetSel () const
| Return the memorised selected order.
int | GetOrderFromPt (int y)
| Calculate the selected order.
bool | HandleOrderVehClick (const Vehicle *u)
void | OrderClick_Goto (int i)
| Handle the click on the goto button.
void | OrderClick_FullLoad (int load_type)
| Handle the click on the full load button.
void | OrderClick_Service (int i)
| Handle the click on the service.
void | OrderClick_NearestDepot (int i)
| Handle the click on the service in nearest depot button.
void | OrderClick_Conditional (int i)
| Handle the click on the conditional order button.
void | OrderClick_Unload (int unload_type)
| Handle the click on the unload button.
void | OrderClick_Nonstop (int non_stop)
| Handle the click on the nonstop button.
void | OrderClick_Skip (int i)
| Handle the click on the skip button.
void | OrderClick_Delete (int i)
| Handle the click on the delete button.
void | OrderClick_Refit (int i)
| Handle the click on the refit button.
## Private Attributes
int | selected_order
OrderPlaceObjectState | goto_type
const Vehicle * | vehicle
| Vehicle owning the orders being displayed and manipulated.

## Detailed Description

Order window code for all vehicles.

At the bottom of the window two button rows are located for changing the orders of the vehicle.

## Top row

The top-row is for manipulating an individual order. What row is displayed depends on the type of vehicle, and whether or not you are the owner of the vehicle.

The top-row buttons of one of your trains or road vehicles is one of the following three cases:

     * +-----------------+-----------------+-----------------+
     * |    NON-STOP     |    FULL_LOAD    |     UNLOAD      | (normal)
     * +-----------------+-----------------+-----------------+
     * |    COND_VAR     | COND_COMPARATOR |   COND_VALUE    | (for conditional orders)
     * +-----------------+-----------------+-----------------+
     * |    NON-STOP     |      REFIT      |     SERVICE     | (for depot orders)
     * +-----------------+-----------------+-----------------+
     *

Airplanes and ships have one of the following three top-row button rows:

     * +--------------------------+--------------------------+
     * |          FULL_LOAD       |          UNLOAD          | (normal)
     * +-----------------+--------+--------+-----------------+
     * |    COND_VAR     | COND_COMPARATOR |   COND_VALUE    | (for conditional orders)
     * +-----------------+--------+--------+-----------------+
     * |            REFIT         |          SERVICE         | (for depot order)
     * +--------------------------+--------------------------+
     *

## Bottom row

The second row (the bottom row) is for manipulating the list of orders:

     * +-----------------+-----------------+-----------------+
     * |      SKIP       |     DELETE      |      GOTO       |
     * +-----------------+-----------------+-----------------+
     *

For vehicles of other companies, both button rows are not displayed.

Definition at line 437 of file order_gui.cpp.

## Member Enumeration Documentation

enum OrdersWindow::DisplayPane`[private]`

Displayed planes of the NWID_SELECTION widgets.

Enumerator:

  DP_LEFT_NONSTOP | Display 'non stop' in the left button of the top row of the train/rv order window.
  DP_LEFT_CONDVAR | Display condition variable in the left button of the top row of the train/rv order window.
  DP_MIDDLE_LOAD | Display 'load' in the middle button of the top row of the train/rv order window.
  DP_MIDDLE_REFIT | Display 'refit' in the middle button of the top row of the train/rv order window.
  DP_MIDDLE_COMPARE | Display compare operator in the middle button of the top row of the train/rv order window.
  DP_RIGHT_UNLOAD | Display 'unload' in the right button of the top row of the train/rv order window.
  DP_RIGHT_SERVICE | Display 'service' in the right button of the top row of the train/rv order window.
  DP_RIGHT_CONDVAL | Display condition value in the right button of the top row of the train/rv order window.
  DP_ROW_LOAD | Display 'load' / 'unload' buttons in the top row of the ship/airplane order window.
  DP_ROW_DEPOT | Display 'refit' / 'service' buttons in the top row of the ship/airplane order window.
  DP_ROW_CONDITIONAL | Display the conditional order buttons in the top row of the ship/airplane order window.

Definition at line 446 of file order_gui.cpp.

## Member Function Documentation

virtual void OrdersWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 937 of file order_gui.cpp.

References _dynlang, DrawOrderString(), DrawString(), Vehicle::GetOrder(), Scrollbar::GetPosition(), GetSpriteSize(), GetStringBoundingBox(), Vehicle::IsOrderListShared(), Scrollbar::IsVisible(), Order::next, SetDParam(), TD_RTL, DynamicLanguages::text_dir, vehicle, Window::vscroll, WD_FRAMERECT_TOP, WD_FRAMETEXT_LEFT, and WD_FRAMETEXT_RIGHT.

int OrdersWindow::GetOrderFromPt | ( | int | y | ) | `[inline, private]`

Calculate the selected order.

The calculation is based on the relative (to the window) y click position and the position of the scrollbar.

Parameters:

  | y | Y-value of the click relative to the window origin

Returns:
  The selected order if the order is valid, else return `INVALID_ORDER`.

Definition at line 490 of file order_gui.cpp.

References Scrollbar::GetCapacity(), Scrollbar::GetPosition(), INVALID_ORDER, NWidgetBase::pos_y, NWidgetBase::resize_y, Window::vscroll, and WD_FRAMERECT_TOP.

Referenced by OnClick(), OnDragDrop(), and OnPlaceObjectAbort().

virtual void OrdersWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 990 of file order_gui.cpp.

References _ctrl_pressed, CMD_MODIFY_ORDER, CMD_MSG, ConvertSpeedToDisplaySpeed(), CS_NUMERAL, Window::DeleteChildWindows(), DoCommandP(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem<&_depot_pool >::Get(), SpecializedStation< Station, false >::Get(), SpecializedStation< Waypoint, true >::Get(), Order::GetConditionComparator(), Order::GetConditionValue(), Order::GetConditionVariable(), Order::GetDepotActionType(), Order::GetDestination(), Order::GetNonStopType(), Vehicle::GetNumOrders(), Vehicle::GetOrder(), GetOrderFromPt(), Order::GetType(), HideDropDownMenu(), HT_DRAG, INVALID_ORDER, INVALID_TILE, Order::IsType(), MOF_STOP_LOCATION, OCV_MAX_SPEED, OCV_REQUIRES_SERVICE, ODATFB_NEAREST_DEPOT, OrderClick_Delete(), OrderClick_FullLoad(), OrderClick_Goto(), OrderClick_Nonstop(), OrderClick_Refit(), OrderClick_Service(), OrderClick_Skip(), OrderClick_Unload(), OrderGetSel(), SetDParam(), ShowDropDownMenu(), ShowQueryString(), SPR_CURSOR_MOUSE, Vehicle::tile, BaseVehicle::type, VEH_AIRCRAFT, VEH_TRAIN, and vehicle.

virtual void OrdersWindow::OnDragDrop | ( | Point | pt,
|  | int | widget |
| ) |  |  | `[inline, virtual]`

A dragged 'object' has been released.

Parameters:

  | pt | the point inside the window where the release took place.
  | widget | the widget where the release took place.

Reimplemented from Window.

Definition at line 1192 of file order_gui.cpp.

References CMD_MOVE_ORDER, CMD_MSG, DoCommandP(), Vehicle::GetNumOrders(), GetOrderFromPt(), INVALID_ORDER, OrderClick_Delete(), OrderGetSel(), Vehicle::tile, and vehicle.

virtual void OrdersWindow::OnDropdownSelect | ( | int | widget,
|  | int | index |
| ) |  |  | `[inline, virtual]`

A dropdown option associated to this window has been selected.

Parameters:

  | widget | the widget (button) that the dropdown is associated with.
  | index | the element in the dropdown that is selected.

Reimplemented from Window.

Definition at line 1154 of file order_gui.cpp.

References CMD_MODIFY_ORDER, CMD_MSG, DoCommandP(), MOF_COND_COMPARATOR, MOF_COND_VARIABLE, OrderClick_Conditional(), OrderClick_FullLoad(), OrderClick_Goto(), OrderClick_NearestDepot(), OrderClick_Nonstop(), OrderClick_Service(), OrderClick_Unload(), Vehicle::tile, and vehicle.

virtual void OrdersWindow::OnInvalidateData | ( | int | data | ) | `[inline, virtual]`

Some data on this window has become invalid.

Parameters:

  | data | information about the changed data.

Reimplemented from Window.

Definition at line 747 of file order_gui.cpp.

References Window::DeleteChildWindows(), GB(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem<&_vehicle_pool >::Get(), Vehicle::GetNumOrders(), HideDropDownMenu(), INVALID_VEH_ORDER_ID, Scrollbar::SetCount(), vehicle, Window::vscroll, and Window::window_number.

virtual EventState OrdersWindow::OnKeyPress | ( | uint16 | key,
|  | uint16 | keycode |
| ) |  |  | `[inline, virtual]`

A key has been pressed.

Parameters:

  | key | the Unicode value of the key.
  | keycode | the untranslated key code including shift state.

Returns:
  ES_HANDLED if the key press has been handled and no other window should receive the event.

Reimplemented from Window.

Definition at line 1214 of file order_gui.cpp.

References Window::ES_HANDLED, Window::ES_NOT_HANDLED, lengthof, OrderClick_Delete(), OrderClick_FullLoad(), OrderClick_Goto(), OrderClick_Nonstop(), OrderClick_Skip(), OrderClick_Unload(), and vehicle.

virtual void OrdersWindow::OnPaint | ( |  | ) | `[inline, virtual]`

The window must be repainted.

Note:
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 931 of file order_gui.cpp.

References Window::DrawWidgets(), and vehicle.

virtual void OrdersWindow::OnPlaceObject | ( | Point | pt,
|  | TileIndex | tile |
| ) |  |  | `[inline, virtual]`

The user clicked some place on the map when a tile highlight mode has been set.

Parameters:

  | pt | the exact point on the map that has been clicked.
  | tile | the tile on the map that has been clicked.

Reimplemented from Window.

Definition at line 1237 of file order_gui.cpp.

References _settings_client, CMD_INSERT_ORDER, CMD_MSG, DoCommandP(), ClientSettings::gui, Order::IsType(), Order::Pack(), GUISettings::quick_goto, Vehicle::tile, and vehicle.

virtual void OrdersWindow::OnQueryTextFinished | ( | char * | str | ) | `[inline, virtual]`

The query window opened from this window has closed.

Parameters:

  | str | the new value of the string, NULL if the window was cancelled or an empty string when the default button was pressed, i.e. StrEmpty(str).

Reimplemented from Window.

Definition at line 1132 of file order_gui.cpp.

References Clamp(), CMD_MODIFY_ORDER, CMD_MSG, ConvertDisplaySpeedToSpeed(), DoCommandP(), Order::GetConditionVariable(), Vehicle::GetOrder(), MOF_COND_VALUE, OCV_LOAD_PERCENTAGE, OCV_MAX_SPEED, OCV_RELIABILITY, OrderGetSel(), StrEmpty(), Vehicle::tile, and vehicle.

virtual void OrdersWindow::OnResize | ( |  | ) | `[inline, virtual]`

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 1292 of file order_gui.cpp.

References Scrollbar::SetCapacityFromWidget(), and Window::vscroll.

void OrdersWindow::OrderClick_Conditional | ( | int | i | ) | `[inline, private]`

Handle the click on the conditional order button.

Parameters:

  | i | Dummy parameter.

Definition at line 593 of file order_gui.cpp.

References ANIMCURSOR_PICKSTATION, HT_RECT, Window::LowerWidget(), and Window::SetWidgetDirty().

Referenced by OnDropdownSelect().

void OrdersWindow::OrderClick_Delete | ( | int | i | ) | `[inline, private]`

Handle the click on the delete button.

Parameters:

  | i | Dummy parameter.

Definition at line 657 of file order_gui.cpp.

References _networking, CMD_DELETE_ORDER, CMD_MSG, DoCommandP(), Vehicle::GetNumOrders(), Vehicle::tile, and vehicle.

Referenced by OnClick(), OnDragDrop(), and OnKeyPress().

void OrdersWindow::OrderClick_FullLoad | ( | int | load_type | ) | `[inline, private]`

Handle the click on the full load button.

Parameters:

  | load_type | the way to load.

Definition at line 545 of file order_gui.cpp.

References CMD_MODIFY_ORDER, CMD_MSG, DoCommandP(), Order::GetLoadType(), Vehicle::GetOrder(), MOF_LOAD, OLF_FULL_LOAD_ANY, OLF_LOAD_IF_POSSIBLE, OrderGetSel(), Vehicle::tile, and vehicle.

Referenced by OnClick(), OnDropdownSelect(), and OnKeyPress().

void OrdersWindow::OrderClick_Goto | ( | int | i | ) | `[inline, private]`

Handle the click on the goto button.

Parameters:

  | i | Dummy parameter.

Definition at line 528 of file order_gui.cpp.

References ANIMCURSOR_PICKSTATION, HT_RECT, Window::IsWidgetLowered(), Window::SetWidgetDirty(), and Window::ToggleWidgetLoweredState().

Referenced by OnClick(), OnDropdownSelect(), and OnKeyPress().

void OrdersWindow::OrderClick_NearestDepot | ( | int | i | ) | `[inline, private]`

Handle the click on the service in nearest depot button.

Parameters:

  | i | Dummy parameter.

Definition at line 577 of file order_gui.cpp.

References _settings_client, CMD_INSERT_ORDER, CMD_MSG, DoCommandP(), ClientSettings::gui, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem< Tpool >::index, Order::MakeGoToDepot(), GUISettings::new_nonstop, Order::next, ODATFB_NEAREST_DEPOT, ODTFB_PART_OF_ORDERS, ONSF_NO_STOP_AT_INTERMEDIATE_STATIONS, Order::Pack(), Order::SetDepotActionType(), Vehicle::tile, VEH_ROAD, VEH_TRAIN, and vehicle.

Referenced by OnDropdownSelect().

void OrdersWindow::OrderClick_Nonstop | ( | int | non_stop | ) | `[inline, private]`

Handle the click on the nonstop button.

Parameters:

  | non_stop | what non-stop type to use; -1 to use the 'next' one.

Definition at line 622 of file order_gui.cpp.

References CMD_MODIFY_ORDER, CMD_MSG, DoCommandP(), Order::GetNonStopType(), Vehicle::GetOrder(), MOF_NON_STOP, ONSF_NO_STOP_AT_INTERMEDIATE_STATIONS, OrderGetSel(), Window::SetWidgetDirty(), Vehicle::tile, and vehicle.

Referenced by OnClick(), OnDropdownSelect(), and OnKeyPress().

void OrdersWindow::OrderClick_Refit | ( | int | i | ) | `[inline, private]`

Handle the click on the refit button.

If ctrl is pressed, cancel refitting, else show the refit window.

Parameters:

  | i | Dummy parameter.

Definition at line 673 of file order_gui.cpp.

References _ctrl_pressed, CMD_ORDER_REFIT, CT_NO_REFIT, DoCommandP(), OrderGetSel(), ShowVehicleRefitWindow(), Vehicle::tile, and vehicle.

Referenced by OnClick().

void OrdersWindow::OrderClick_Skip | ( | int | i | ) | `[inline, private]`

Handle the click on the skip button.

If ctrl is pressed, skip to selected order, else skip to current order + 1

Parameters:

  | i | Dummy parameter.

Definition at line 643 of file order_gui.cpp.

References _ctrl_pressed, CMD_MSG, CMD_SKIP_TO_ORDER, Vehicle::cur_order_index, DoCommandP(), Vehicle::GetNumOrders(), Vehicle::tile, and vehicle.

Referenced by OnClick(), and OnKeyPress().

int OrdersWindow::OrderGetSel | ( |  | ) | const`[inline, private]`

Return the memorised selected order.

Returns:
  the memorised order if it is a vaild one else return the number of orders

Definition at line 476 of file order_gui.cpp.

References Vehicle::GetNumOrders(), and vehicle.

Referenced by OnClick(), OnDragDrop(), OnQueryTextFinished(), OrderClick_FullLoad(), OrderClick_Nonstop(), OrderClick_Refit(), OrderClick_Service(), OrderClick_Unload(), and SetStringParameters().

virtual void OrdersWindow::SetStringParameters | ( | int | widget | ) | const`[inline, virtual]`

Initialize string parameters for a widget.

Calls to this function are made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters:

  | widget | Widget number.

Reimplemented from Window.

Definition at line 969 of file order_gui.cpp.

References ConvertSpeedToDisplaySpeed(), Order::GetConditionValue(), Order::GetConditionVariable(), Vehicle::GetOrder(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem< Tpool >::index, Order::IsType(), OCV_MAX_SPEED, OrderGetSel(), SetDParam(), and vehicle.

virtual void OrdersWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 711 of file order_gui.cpp.

References _settings_game, FONT_HEIGHT_NORMAL, GetStringBoundingBox(), INVALID_STRING_ID, maxdim(), GameSettings::order, OrderSettings::timetabling, WD_FRAMERECT_BOTTOM, and WD_FRAMERECT_TOP.

The documentation for this struct was generated from the following file:

- src/order_gui.cpp